#include <ESP8266WiFi.h>          //https://github.com/esp8266/Arduino

//for LED status
#include <Ticker.h>
Ticker ticker;

//needed for library
#include <TimeLib.h> 
#include <DNSServer.h>
#include <ESP8266WebServer.h>
#include <WiFiManager.h>         //https://github.com/tzapu/WiFiManager
//#include <NtpClientLib.h>
ESP8266WebServer server(80);
#include <WiFiUdp.h>;
WiFiUDP UDP;


void tick()
{
  //toggle state
  int state = digitalRead(BUILTIN_LED);  // get the current state of GPIO1 pin
  digitalWrite(BUILTIN_LED, !state);     // set pin to the opposite state
}

//gets called when WiFiManager enters configuration mode
void configModeCallback (WiFiManager *myWiFiManager) {
//  Serial.println("Entered config mode");
 // Serial.println(WiFi.softAPIP());
  ////if you used auto generated SSID, print it
//  Serial.println(myWiFiManager->getConfigPortalSSID());
  //entered config mode, make led toggle faster
  ticker.attach(0.2, tick);
}

unsigned int localPort = 8888;  // local port to listen for UDP packets
// variables from hall sensor example
 int refsig = 200; 
 int val;
 int prev_val = 0;
 unsigned long  hall_t, tim, cur_t, elapsed_time, vis_t, rev_t, rot_time, seg_t,seg_t2; 
//unsigned long hall_interval =  3000000;  // 3 million microseconds = 3 seconds  --check the hall timing
unsigned long hall_interval = 10000000;  // 10 million microseconds = 10 seconds  --check the hall timing
//unsigned long ntp_sync_time = 900000000;  // 900 million microseconds = 15 minutes  --check the NTP timing
int rot_text;
 //variable of 32 characters array
char pov_text1[18];
char pov_text2[18];
char pov_text3[18];
float rotation_offset = 0.88;

IPAddress timeServerIP;          // time.nist.gov NTP server address
const char* NTPServerName = "2.us.pool.ntp.org";
const int NTP_PACKET_SIZE = 48;  // NTP time stamp is in the first 48 bytes of the message
byte NTPBuffer[NTP_PACKET_SIZE]; // buffer to hold incoming and outgoing packets
int8_t timeZone = -5;  // EST-- New York, Detroit
 //int8_t minutesTimeZone = 0;
//bool wifiFirstConnected = false;
/**********************************************************************
 * 
 * NTP Stuff
 * 
 * 
 */
// void onSTAConnected (WiFiEventStationModeConnected ipInfo) {
//    //Serial.printf ("Connected to %s\r\n", ipInfo.ssid.c_str ());
//}
//
//
//// Start NTP only after IP network is connected
//void onSTAGotIP (WiFiEventStationModeGotIP ipInfo) {
//   // Serial.printf ("Got IP: %s\r\n", ipInfo.ip.toString ().c_str ());
//    //Serial.printf ("Connected: %s\r\n", WiFi.status () == WL_CONNECTED ? "yes" : "no");
//    //digitalWrite (ONBOARDLED, LOW); // Turn on LED
//    wifiFirstConnected = true;
//}
//
//// Manage network disconnection
//void onSTADisconnected (WiFiEventStationModeDisconnected event_info) {
//  //  Serial.printf ("Disconnected from SSID: %s\n", event_info.ssid.c_str ());
//  //  Serial.printf ("Reason: %d\n", event_info.reason);
//  //  digitalWrite (ONBOARDLED, HIGH); // Turn off LED
//    NTP.stop(); // NTP sync can be disabled to avoid sync errors
//}
//
//void processSyncEvent (NTPSyncEvent_t ntpEvent) {
//    if (ntpEvent) {
//      //  Serial.print ("Time Sync error: ");
//      String t_stuff = ("Time Sync error: ");
//      t_stuff.toCharArray(pov_text3,18) ;
//    }
//        if (ntpEvent == noResponse){
//       //     Serial.println ("NTP server not reachable");
//       String t_stuff = ("not reachable ");
//       t_stuff.toCharArray(pov_text3,18) ;
//        } else if (ntpEvent == invalidAddress){
//       //     Serial.println ("Invalid NTP server address");
//        String t_stuff = ("Inv NTP serv");
//       t_stuff.toCharArray(pov_text3,18) ;
//    } else {
//      //  Serial.print ("Got NTP time: ");
//              String t_stuff = ("Got NTP time:");
//       t_stuff.toCharArray(pov_text3,18) ;
//      //  Serial.println (NTP.getTimeDateString (NTP.getLastNTPSync ()));
//      //(NTP.getTimeDateString (NTP.getLastNTPSync ()));
//    }
//}
//
//boolean syncEventTriggered = false; // True if a time event has been triggered
//NTPSyncEvent_t ntpEvent; // Last triggered event
/*
 * 
 * End of NTP functions
 * 
 * 
 ***********************************************************************************/
/*
 * 
 * 
 * Setup the LEDs for the POV
 * 
 * 
 */
int LED1=4;
int LED2=12;
int LED3=13;
int LED4=14;
int LED5 = 5;
/*
 * 
 * 
 * This code is credited from https://www.instructables.com/id/ATtiny8545-POV-Display/
 * I changed alot of it but the concept is perfect for the task.
 * 
 */

int a[] = {1, 6, 26, 6, 1};
int b[] = {31, 21, 21, 10, 0};
int c[] = {14, 17, 17, 10, 0};
int d[] = {31, 17, 17, 14, 0};
int e[] = {31, 21, 21, 17, 0};
int f[] = {31, 20, 20, 16, 0};
int g[] = {14, 17, 19, 10, 0};
int h[] = {31, 4, 4, 4, 31};
int i[] = {0, 17, 31, 17, 0};
int j[] = {0, 17, 30, 16, 0};
int k[] = {31, 4, 10, 17, 0};
int l[] = {31, 1, 1, 1, 0};
int m[] = {31, 12, 3, 12, 31};
int n[] = {31, 12, 3, 31, 0};
int o[] = {14, 17, 17, 14, 0};
int p[] = {31, 20, 20, 8, 0};
int q[] = {14, 17, 19, 14, 2};
int r[] = {31, 20, 22, 9, 0};
int s[] = {8, 21, 21, 2, 0};
int t[] = {16, 16, 31, 16, 16};
int u[] = {30, 1, 1, 30, 0};
int v[] = {24, 6, 1, 6, 24};
int w[] = {28, 3, 12, 3, 28};
int x[] = {17, 10, 4, 10, 17};
int y[] = {17, 10, 4, 8, 16};
int z[] = {19, 21, 21, 25, 0};
int eos[] = {0, 1, 0, 0, 0};
int excl[] = {0, 29, 0, 0, 0};
int ques[] = {8, 19, 20, 8, 0};
int hyph[] = {0, 4, 4, 0, 0};
int one[] = {0, 17, 31, 1, 0};
int two[] = {11, 21, 21, 13, 0};
int three[] = {10, 17, 21, 10, 0};
int four[] = {24, 4, 4, 31, 0};
int five[] = {24, 21, 21, 2, 0};
int six[] = {14, 21, 21, 2, 0};
int seven[] = {16, 19, 4, 24, 0};
int eight[] = {10, 21, 21, 10, 0};
int nine[] = {8, 21, 21, 14, 0};
int zero[] = {14, 17, 17, 14, 0};
int spacer[] = {0, 0, 0, 0, 0};
int colon[] = {0, 0, 10, 0, 0};
int hash[] = {10, 31, 10, 31, 10};


void displayLine(int line)
{
  int myline;
  myline = line;
  if (myline>=16) {digitalWrite(LED1, HIGH); myline-=16;} else {digitalWrite(LED1, LOW);}
  if (myline>=8)  {digitalWrite(LED2, HIGH); myline-=8;}  else {digitalWrite(LED2, LOW);}
  if (myline>=4)  {digitalWrite(LED3, HIGH); myline-=4;}  else {digitalWrite(LED3, LOW);}
  if (myline>=2)  {digitalWrite(LED4, HIGH); myline-=2;}  else {digitalWrite(LED4, LOW);}
  if (myline>=1)  {digitalWrite(LED5, HIGH); myline-=1;}  else {digitalWrite(LED5, LOW);} 
}

void displayChar(char cv,long elapsed_time)
{
  int delayTime=elapsed_time/(100);
  int charBreak=elapsed_time/(120);
  switch (cv) {
 case'A': for (int i = 0; i <5; i++){displayLine(a[i]);delayMicroseconds(delayTime);}break;
 case'a': for (int i = 0; i <5; i++){displayLine(a[i]);delayMicroseconds(delayTime);}break;
 case'B': for (int i = 0; i <5; i++){displayLine(b[i]);delayMicroseconds(delayTime);}break;
 case'b': for (int i = 0; i <5; i++){displayLine(b[i]);delayMicroseconds(delayTime);}break;
 case'C': for (int i = 0; i <5; i++){displayLine(c[i]);delayMicroseconds(delayTime);}break;
 case'c': for (int i = 0; i <5; i++){displayLine(c[i]);delayMicroseconds(delayTime);}break;
 case'D': for (int i = 0; i <5; i++){displayLine(d[i]);delayMicroseconds(delayTime);}break;
 case'd': for (int i = 0; i <5; i++){displayLine(d[i]);delayMicroseconds(delayTime);}break;
 case'E': for (int i = 0; i <5; i++){displayLine(e[i]);delayMicroseconds(delayTime);}break;
 case'e': for (int i = 0; i <5; i++){displayLine(e[i]);delayMicroseconds(delayTime);}break;
 case'F': for (int i = 0; i <5; i++){displayLine(f[i]);delayMicroseconds(delayTime);}break;
 case'f': for (int i = 0; i <5; i++){displayLine(f[i]);delayMicroseconds(delayTime);}break;
 case'G': for (int i = 0; i <5; i++){displayLine(g[i]);delayMicroseconds(delayTime);}break;
 case'g': for (int i = 0; i <5; i++){displayLine(g[i]);delayMicroseconds(delayTime);}break;
 case'H': for (int i = 0; i <5; i++){displayLine(h[i]);delayMicroseconds(delayTime);}break;
 case'h': for (int i = 0; i <5; i++){displayLine(h[i]);delayMicroseconds(delayTime);}break;
 case'I': for (int iz = 0; iz <5; iz++){displayLine(i[iz]);delayMicroseconds(delayTime);}break;
 case'i': for (int iz = 0; iz <5; iz++){displayLine(i[iz]);delayMicroseconds(delayTime);}break;
 case'J': for (int i = 0; i <5; i++){displayLine(j[i]);delayMicroseconds(delayTime);}break;
 case'j': for (int i = 0; i <5; i++){displayLine(j[i]);delayMicroseconds(delayTime);}break;
 case'K': for (int i = 0; i <5; i++){displayLine(k[i]);delayMicroseconds(delayTime);}break;
 case'k': for (int i = 0; i <5; i++){displayLine(k[i]);delayMicroseconds(delayTime);}break;
 case'L': for (int i = 0; i <5; i++){displayLine(l[i]);delayMicroseconds(delayTime);}break;
 case'l': for (int i = 0; i <5; i++){displayLine(l[i]);delayMicroseconds(delayTime);}break;
 case'M': for (int i = 0; i <5; i++){displayLine(m[i]);delayMicroseconds(delayTime);}break;
 case'm': for (int i = 0; i <5; i++){displayLine(m[i]);delayMicroseconds(delayTime);}break;
 case'N': for (int i = 0; i <5; i++){displayLine(n[i]);delayMicroseconds(delayTime);}break;
 case'n': for (int i = 0; i <5; i++){displayLine(n[i]);delayMicroseconds(delayTime);}break;
 case'O': for (int i = 0; i <5; i++){displayLine(o[i]);delayMicroseconds(delayTime);}break;
 case'o': for (int i = 0; i <5; i++){displayLine(o[i]);delayMicroseconds(delayTime);}break;
 case'P': for (int i = 0; i <5; i++){displayLine(p[i]);delayMicroseconds(delayTime);}break;
 case'p': for (int i = 0; i <5; i++){displayLine(p[i]);delayMicroseconds(delayTime);}break;
 case'Q': for (int i = 0; i <5; i++){displayLine(q[i]);delayMicroseconds(delayTime);}break;
 case'q': for (int i = 0; i <5; i++){displayLine(q[i]);delayMicroseconds(delayTime);}break;
 case'R': for (int i = 0; i <5; i++){displayLine(r[i]);delayMicroseconds(delayTime);}break;
 case'r': for (int i = 0; i <5; i++){displayLine(r[i]);delayMicroseconds(delayTime);}break;
 case'S': for (int i = 0; i <5; i++){displayLine(s[i]);delayMicroseconds(delayTime);}break;
 case's': for (int i = 0; i <5; i++){displayLine(s[i]);delayMicroseconds(delayTime);}break;
 case'T': for (int i = 0; i <5; i++){displayLine(t[i]);delayMicroseconds(delayTime);}break;
 case't': for (int i = 0; i <5; i++){displayLine(t[i]);delayMicroseconds(delayTime);}break;
 case'U': for (int i = 0; i <5; i++){displayLine(u[i]);delayMicroseconds(delayTime);}break;
 case'u': for (int i = 0; i <5; i++){displayLine(u[i]);delayMicroseconds(delayTime);}break;
 case'V': for (int i = 0; i <5; i++){displayLine(v[i]);delayMicroseconds(delayTime);}break;
 case'v': for (int i = 0; i <5; i++){displayLine(v[i]);delayMicroseconds(delayTime);}break;
 case'W': for (int i = 0; i <5; i++){displayLine(w[i]);delayMicroseconds(delayTime);}break;
 case'w': for (int i = 0; i <5; i++){displayLine(w[i]);delayMicroseconds(delayTime);}break;
 case'X': for (int i = 0; i <5; i++){displayLine(x[i]);delayMicroseconds(delayTime);}break;
 case'x': for (int i = 0; i <5; i++){displayLine(x[i]);delayMicroseconds(delayTime);}break;
 case'Y': for (int i = 0; i <5; i++){displayLine(y[i]);delayMicroseconds(delayTime);}break;
 case'y': for (int i = 0; i <5; i++){displayLine(y[i]);delayMicroseconds(delayTime);}break;
 case'Z': for (int i = 0; i <5; i++){displayLine(z[i]);delayMicroseconds(delayTime);}break;
 case'z': for (int i = 0; i <5; i++){displayLine(z[i]);delayMicroseconds(delayTime);}break;
 case'!': for (int i = 0; i <5; i++){displayLine(excl[i]);delayMicroseconds(delayTime);}break;
 case'?': for (int i = 0; i <5; i++){displayLine(ques[i]);delayMicroseconds(delayTime);}break;
 case'.': for (int i = 0; i <5; i++){displayLine(eos[i]);delayMicroseconds(delayTime);}break;
 case'-': for (int i = 0; i <5; i++){displayLine(hyph[i]);delayMicroseconds(delayTime);}break;
 case'1': for (int i = 0; i <5; i++){displayLine(one[i]);delayMicroseconds(delayTime);}break;
 case'2': for (int i = 0; i <5; i++){displayLine(two[i]);delayMicroseconds(delayTime);}break;
 case'3': for (int i = 0; i <5; i++){displayLine(three[i]);delayMicroseconds(delayTime);}break;
 case'4': for (int i = 0; i <5; i++){displayLine(four[i]);delayMicroseconds(delayTime);}break;
 case'5': for (int i = 0; i <5; i++){displayLine(five[i]);delayMicroseconds(delayTime);}break;
 case'6': for (int i = 0; i <5; i++){displayLine(six[i]);delayMicroseconds(delayTime);}break;
 case'7': for (int i = 0; i <5; i++){displayLine(seven[i]);delayMicroseconds(delayTime);}break;
 case'8': for (int i = 0; i <5; i++){displayLine(eight[i]);delayMicroseconds(delayTime);}break;
 case'9': for (int i = 0; i <5; i++){displayLine(nine[i]);delayMicroseconds(delayTime);}break;
 case'0': for (int i = 0; i <5; i++){displayLine(o[i]);delayMicroseconds(delayTime);}break;
 case' ': for (int i = 0; i <5; i++){displayLine(spacer[i]);delayMicroseconds(delayTime);}break;
 case':': for (int i = 0; i <5; i++){displayLine(colon[i]);delayMicroseconds(delayTime);}break;
}
displayLine(0);
  delayMicroseconds(charBreak);
}



void displayString(char* s,long elapsed_time) //for each character
{
   int xtra_sp = 18 - strlen(s);
  for (int ic = 0; ic<=strlen(s); ic++)
  {
   
    displayChar(s[ic],elapsed_time);

  }
    for (int  ic= 0; ic<=xtra_sp; ic++)
  {
   
    displayChar(' ',elapsed_time);

  }
}



/*
 * 
 * 
 * Below is the web page, "handleRoot" that will be shown initially
 * 
 * The ajax libarary from Google, https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js should be up to date.
 * If there is an update, or the library becomes archaic, update the line to a better library.
 * 
 */



 
void handleRoot() {

  String webroot;
  webroot="<html>\n";
  webroot+="<head>\n";

  webroot+="<meta  charset='utf-8'>\n";
  webroot+="<meta name='viewport' content='width=device-width, initial-scale=1'>\n";
  webroot+="<script src='https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js'></script>\n";
  webroot+="<script>\n";
  webroot+="$(document).ready(function(){\n";
  webroot+="var hh;\n";
  webroot+="var jj;\n";
  webroot+="$('#save_button').click(function(e){\n";
  webroot+="e.preventDefault();\n";
  webroot+="hh = $('#date_hh').val();\n";
  webroot+="jj = $('#date_jj').val();\n";
  webroot+="$.get('/save?hh=' + hh + '&jj=' + jj, function(data){\n";
  webroot+="console.log(data);\n";
  webroot+="});\n";
  webroot+="});\n";
  webroot+="});\n";
  webroot+="</script>\n";
  webroot+="<title>FAN POV</title>\n";
  webroot+="<style>\n";
  webroot+="body { background-color: #cccccc; font-family: Arial, Helvetica, Sans-Serif; Color: #000088; }\n";
  webroot+="</style>\n";
  webroot+="</head>\n";
  webroot+="<body><form>\n";
  webroot+="<h1>FAN POV</h1>\n";
  webroot+="<table><tr><td>\n";
  webroot+="<input type='text' name='date_hh' id='date_hh' maxlength='18' autofocus> Text1 Max18char.\n";
  webroot+="</td></tr><tr><td>\n";
  webroot+="<input type='text' name='date_jj' id='date_jj' maxlength='18' autofocus> Text2  Max18char.\n";
  webroot+="</td></tr><tr><td>\n";

  webroot+="<button type='submit' id='save_button'>Save</button>\n";
  webroot+="</td></tr><tr><td>letters,numbers,.,-,:,?,!-- fill both text boxes.</td></tr></table></form>\n";
  webroot+="<hr>\n";
  webroot+="<span name='myIframe'  ></span>\n";
  webroot+="</body>\n";
        
  server.send(200, "text/html", webroot);

}


/*
 * 
 * 
 * "handleSave" is the reciever for the ajax call
 * 
 */

void handleSave() {
  if ((server.arg("hh")!= "")&& (server.arg("jj")!= "")){

    server.arg("hh").toCharArray(pov_text1,18) ;
    server.arg("jj").toCharArray(pov_text2,18) ;
    //Serial.println("Text Input-----------------------------------------------: " + server.arg("hh"));
  }
}

void time_display(){

  String  t_stuffm, t_stuff;
    time_t t=now();
    if(minute(t)<10){
      t_stuffm=(String("0") + String(minute(t)));
    } else {t_stuffm=String(minute(t));}
    
 
t_stuff = String(hour(t)) + String(":") + t_stuffm;
    
    t_stuff.toCharArray(pov_text3,18) ;
}
/********
 * 
 * Second Attempt at UDP NTP
 * 
 */

void startUDP() {
  Serial.println("Starting UDP");
  UDP.begin(123);                          // Start listening for UDP messages on port 123
  Serial.print("Local port:\t");
  Serial.println(UDP.localPort());
  Serial.println();
}


time_t getNtpTime()
{
  while (UDP.parsePacket() > 0) ; // discard any previously received packets
  //Serial.println("Transmit NTP Request");
  sendNTPpacket(timeServerIP);
  uint32_t beginWait = millis();
  while (millis() - beginWait < 1500) {
    int size = UDP.parsePacket();
    if (size >= NTP_PACKET_SIZE) {
      Serial.println("Receive NTP Response");
      UDP.read(NTPBuffer, NTP_PACKET_SIZE);  // read packet into the buffer
      unsigned long secsSince1900;
      // convert four bytes starting at location 40 to a long integer
      secsSince1900 =  (unsigned long)NTPBuffer[40] << 24;
      secsSince1900 |= (unsigned long)NTPBuffer[41] << 16;
      secsSince1900 |= (unsigned long)NTPBuffer[42] << 8;
      secsSince1900 |= (unsigned long)NTPBuffer[43];
      return secsSince1900 - 2208988800UL  + adjustDstEST() + timeZone * SECS_PER_HOUR;
    }
  }
  Serial.println("No NTP Response :-(");
  return 0; // return 0 if unable to get the time
}

int adjustDstEST()
{
 // second sunday of march
 //Begin DST: Sunday March 14 - (1 + y*5/4) mod 7
 int beginDSTDate=  (14-(1 + year() * 5/4) % 7);
 //Serial.println(beginDSTDate);
 int beginDSTMonth=3;
 //first Sunday of November
 // End DST: Sunday November 7 - (1 + y*5/4) mod 7;
 int endDSTDate=   (7-(1 + year() * 5/4) % 7);
 //Serial.println(endDSTDate);
 int endDSTMonth=11;
 // DST is valid as:
 if (((month() > beginDSTMonth) && (month() < endDSTMonth))
     || ((month() == beginDSTMonth) && (day() >= beginDSTDate)) 
     || ((month() == endDSTMonth) && (day() <= endDSTDate)))
 return 3600;  // DST = utc +1 hour
 else return 0; // EST
}




void sendNTPpacket(IPAddress& address) {
  memset(NTPBuffer, 0, NTP_PACKET_SIZE);  // set all bytes in the buffer to 0
  // Initialize values needed to form NTP request
  NTPBuffer[0] = 0b11100011;   // LI, Version, Mode
  // send a packet requesting a timestamp:
  UDP.beginPacket(address, 123); // NTP requests are to port 123
  UDP.write(NTPBuffer, NTP_PACKET_SIZE);
  UDP.endPacket();
}

inline int getSeconds(uint32_t UNIXTime) {
  return UNIXTime % 60;
}

inline int getMinutes(uint32_t UNIXTime) {
  return UNIXTime / 60 % 60;
}

inline int getHours(uint32_t UNIXTime) {
  return UNIXTime / 3600 % 24;
}



void setup() {

    // put your setup code here, to run once:
  //set led pin as output
  pinMode(BUILTIN_LED, OUTPUT);
    // start ticker with 0.5 because we start in AP mode and try to connect
  ticker.attach(0.6, tick); 
  
   pinMode(A0, INPUT);
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(LED4, OUTPUT);
  pinMode(LED5, OUTPUT);

  
  rot_text = 0;
    //WiFiManager
    //Local intialization. Once its business is done, there is no need to keep it around
    WiFiManager wifiManager;
    //reset saved settings
    //wifiManager.resetSettings();
    //set custom ip for portal
    //wifiManager.setAPStaticIPConfig(IPAddress(10,0,1,1), IPAddress(10,0,1,1), IPAddress(255,255,255,0));

  //set callback that gets called when connecting to previous WiFi fails, and enters Access Point mode
  wifiManager.setAPCallback(configModeCallback);
  
    //fetches ssid and pass from eeprom and tries to connect
    //if it does not connect it starts an access point with the specified name
    //here  "AutoConnectAP"
    //and goes into a blocking loop awaiting configuration
    if (!wifiManager.autoConnect("POV_AP", "password_for_connection")){
    Serial.println("failed to connect and hit timeout");
    //reset and try again, or maybe put it to deep sleep
    ESP.reset();
    delay(1000);
  }
    //or use this for auto generated name ESP + ChipID
    //wifiManager.autoConnect();
    
    //if you get here you have connected to the WiFi
//        Serial.begin(115200);
//        Serial.println("connected...yeey :)");
//        Serial.println(WiFi.localIP());

       


 

  
  server.on("/", handleRoot);     // The main page is called
  server.on("/save", handleSave);
      server.begin();
     //Serial.println ( "HTTP server started" );

IPAddress broadCast = WiFi.localIP();
// The next few lines show the IP address on your network to connect to web page
// If you see the ip address on your fan POV, you should be connected
String ip_Address = String(broadCast[0]) + String(".") +\
  String(broadCast[1]) + String(".") +\
  String(broadCast[2]) + String(".") +\
  String(broadCast[3]);
  ip_Address.toCharArray(pov_text1,17);
   startUDP();
///*
// * 
// * NTP Setup after Wifi connected
// * 
// */
// static WiFiEventHandler e1, e2, e3;
//     NTP.onNTPSyncEvent ([](NTPSyncEvent_t event) {
//        ntpEvent = event;
//        syncEventTriggered = true;
//    });
//
//    // Deprecated
//    /*WiFi.onEvent([](WiFiEvent_t e) {
//        Serial.printf("Event wifi -----> %d\n", e);
//    });*/
//
//    e1 = WiFi.onStationModeGotIP (onSTAGotIP);// As soon WiFi is connected, start NTP Client
//    e2 = WiFi.onStationModeDisconnected (onSTADisconnected);
//    e3 = WiFi.onStationModeConnected (onSTAConnected);
//   // setSyncProvider(getNtpTime);
//       // setSyncProvider(NTP.getTimeDateString ());
//       // NTP.getTimeDateString ();
/*
 * 
 * 
 * 
 * 
 * 
 * 
 */

 WiFi.hostByName(NTPServerName, timeServerIP); // Get the IP address of the NTP server
 
  //Serial.print("Time server IP:\t");
 // Serial.println(timeServerIP);
  
 // Serial.println("\r\nSending NTP request ...");
  sendNTPpacket(timeServerIP);  
  
  setSyncProvider(getNtpTime);
    setSyncInterval(3600000UL);
}





/*
 * 
 * Hall effect rotation measure
 * 
 */
long hall_rot_t() {
  int i=0;
  while(i<2){
  int sig = analogRead(A0); //read raw value of hall sensor
   if (sig > refsig) val = HIGH; //convert it to digital 0,1 form
   else val = LOW;
   if (prev_val == 0 && val == 1) { //check for rising edge
     cur_t = micros();
 rot_time = (cur_t-tim)*rotation_offset;
     tim = micros();
     i++;
   }
   prev_val = val;
  }
//  Serial.print(rot_time);
//  Serial.print("' ");
//  Serial.print(cur_t);
//  Serial.print(", ");
//  Serial.println(tim);
  return rot_time;
}


/*************************************************************************
 * 
 * This code loops over and over at high speed
 * Some of this code was gleened from the hall effect sensor "rpm" example
 * 
 * 
 */


 
void loop() {
     // put your main code here, to run repeatedly:
 

     server.handleClient();
//    /*
//     * NTP if
//     */
//    if (wifiFirstConnected) {
//        wifiFirstConnected = false;
//        NTP.begin ("2.us.pool.ntp.org", timeZone, true, minutesTimeZone);
//        NTP.setInterval (63);
//    }
//    if (syncEventTriggered) {
//        processSyncEvent (ntpEvent);
//        syncEventTriggered = false;
//    }


     
     //Serial.println(rev_t);
     hall_t = micros();
     if(hall_t > rev_t){          // every "hall interval"
      elapsed_time = hall_rot_t();
      rev_t = hall_t + hall_interval;
      rot_text++;     //every hall interval increase the display set
      if(rot_text>=3){rot_text=0;}
      time_display();
     } 
       switch (rot_text) {
 case 0:    displayString(pov_text1,elapsed_time);break;
  case 1:    displayString(pov_text2,elapsed_time);break;
 case 2:    displayString(pov_text3,elapsed_time);break;
       }

}
